/*
 * DrvDAC.h
 *
 *  Created on: 2011/11/30
 *      Author: Eric.Lai
 */

#ifndef DRVDAC_H_
#define DRVDAC_H_
#include "HY16F198.h"

#ifndef E_FAIL
#define E_FAIL		1
#endif
#define E_DRVDAC_ARGUMENT E_FAIL

#ifndef E_SUCCESS
#define E_SUCCESS		0
#endif
/*
typedef enum
{
	E_DAC_VDD3V = 0,
	E_DAC_VSSA  =0,
	E_DAC_VDDA  =1,
	E_DAC_OPO   =1,
	E_DAC_REFO  =2,
	E_DAC_AIO6  =3,
	E_DAC_AIO7  =3
} E_DAC_INPUT;//*/


typedef enum
{
	E_DAC_PVDD3V =0,
	E_DAC_PVDDA  =1,
	E_DAC_PREFO  =2,
	E_DAC_POPO   =3,
	E_DAC_PAIO4  =4,
	E_DAC_PAIO5  =5,
	E_DAC_PAIO6  =6,
	E_DAC_PAIO7  =7
} E_DAC_PINPUT;
typedef enum
{
	E_DAC_NVSSA  =0,
	E_DAC_NREFO  =1,
	E_DAC_NOPO   =2,
	E_DAC_NAIO7  =3
}E_DAC_NINPUT;

#ifdef  DAC_BASE
#define R_DAC_CTRL1  (DAC_BASE+OFFSET00)
#define R_DAC_CTRL2  (DAC_BASE+OFFSET04)
#define PT3_28       0X40828

#endif

#define DAPS    			4
#define DANS    			2
#define DAOE    			1
#define ENDA    			0
#define DAPS_MASK  			(DAPS+MASK)
#define DANS_MASK  			(DANS+MASK)
#define DAOE_MASK 			(DAOE+MASK)
#define ENDA_MASK  			(ENDA+MASK)
#define DAPS_MAX   			7 //3
#define DANS_MAX   			3

#define DABIT    			0
#define DABIT_MAX   			255

unsigned int DrvDAC_Open(unsigned int uPinput ,unsigned int uNinput,unsigned int uDAO);
void DrvDAC_Close(void);
void DrvDAC_Enable(void);
void DrvDAC_Disable(void);
void DrvDAC_EnableOutput(void);
void DrvDAC_DisableOutput(void);
unsigned int DrvDAC_Pinput(unsigned int uPinput);
unsigned int DrvDAC_Ninput(unsigned int uNinput);
unsigned int DrvDAC_DABIT(unsigned int uDABIT);

unsigned int DrvDAC_SetoutputIO(unsigned int uio);

#endif /* DRVDAC_H_ */
