
OUTPUT_FORMAT("elf32-nds32", "elf32-nds32", "elf32-nds32")
OUTPUT_ARCH(nds32)
/* define entry point of the program */
ENTRY(main)

_ILM_BASE = 0x00080000; /* ILM base address */
_DLM_BASE = 0x00000000; /* DLM base address */
_ILM_SIZE = 0x80000; /*512Kb*/
_DLM_SIZE = 0x2000; /*8Kb*/
MEMORY
{

  ROM (rx) : ORIGIN = 0x00080000, LENGTH = 8K
  FLASH (rx) : ORIGIN = 0x00090000, LENGTH = 64K
  SRAM (rw!x) : ORIGIN = 0x00000000, LENGTH = 8K
}

SECTIONS
{
	_DLM_BASE = 0x00000000;
	__bss_start = 0x00000000;	
	__data_lmastart = 0x00000000;	
	__data_start = 0x00000000;	
	_edata = 0x00000000;	 
	_end = 0x00000000;	 
	_lmaend = 0x00000000;	 
	mr7 = 0x00000003;
	_DLM_SIZE = 0x00002000;	 
/*	_FP_BASE_ = 0x0007ff00;		*/
	_ILM_BASE = 0x00080000;	
	_ILM_SIZE = 0x00080000;	  
	_start2 = 0x00080000;	
	_GoISP = 0x00080004;	 
	_GoMain = 0x00080008;
	_InitStatus = 0x0008012a;	 
	_INFRead = 0x00080154;	
	_FlashMainErase = 0x00080380;	
	_ISPStart = 0x000803d4;
	ISPLoop = 0x000803fc;	 
/*	ROM_BurnWord = 0x00080cce;	*/
	_ITB_BASE_ = 0x00080d48;		
	ROM_BurnPage = 0x00080d90;	
	PageErase = 0x00080e94;	 
	MassErase = 0x00080f02;	 
	SectorErase = 0x00080f6e;	 
	ROM_IntoSleep = 0x00081028; 
	ROM_LowSpeedMode =0x00081088;
	ROM_INX = 0x00080e34;
	ROM_INY = 0x00080d50;	
}


SECTIONS
{ 
  .start         :
  {
    *(.start)
  }> ROM  
  
  .Eric_init          :
  {
    *(.Eric_init)
  } > FLASH
  
  .text           :
  {
    *(.nds32_init .text .stub .text.* )
  } > FLASH

  .rodata         : { *( .rodata .rodata.* .gnu.linkonce.r.*) } > FLASH
  /* Adjust the address for the data segment.  We want to adjust up to
     the same address within the page on the next page up.  */
  /* Ensure the __preinit_array_start label is properly aligned.  We
     could instead move the label definition inside the section, but
     the linker would then create the section even if it turns out to
     be empty, which isn't pretty.  */
  .jcr            : { KEEP (*(.jcr)) } > SRAM 
  /*. = DATA_SEGMENT_RELRO_END (0, .);*/
  PROVIDE (_data = .);
  __data_lmastart = LOADADDR (.data);
  PROVIDE(__data_begin = .);
  /*. = ALIGN(4);*/
  .data           :
  {
    __data_start = .;
    *(.data .data.* .gnu.linkonce.d.*)
    __data_end = .;
  } > SRAM AT>FLASH
  . = ALIGN(4);
  /* We want the small data sections together, so single-instruction offsets
     can access them all, and initialized data all before uninitialized, so
     we can shorten the on-disk segment size.  */
  .sdata_d          :
  {
    __dataG_start = .;
    *(.sdata_d .sdata_d.*)
  }  > SRAM AT>FLASH
  .sdata_w          :
  {
    *(.sdata_w .sdata_w.*)
  }  > SRAM AT>FLASH 
  .sdata_h          :
  {
    *(.sdata_h .sdata_h.*)
  } > SRAM AT>FLASH 
  .sdata_b          :
  {
    *(.sdata_b .sdata_b.*)
  . = ALIGN(4);
    __dataG_end = .;
  } > SRAM AT>FLASH 
  _edata = SIZEOF (.data);
  _lmaend = .;
  PROVIDE (edata = .);
  . = ALIGN(4);
  PROVIDE (_bstart = .);
  __bss_start = .;
  PROVIDE (__sbss_start = .);
  PROVIDE (___sbss_start = .);
  .sbss_b           :
  {
    *(.sbss_b .sbss_b.*)
    . = ALIGN(2);
  } > SRAM 
  .sbss_h           :
  {
    *(.sbss_h .sbss_h.*)
    . = ALIGN(4);
  } > SRAM 
  .sbss_w           :
  {
    *(.sbss_w .sbss_w.*)
  } > SRAM 
  PROVIDE (__sbss_end = .);
  PROVIDE (___sbss_end = .);
  PROVIDE(__bss_begin = .);
  .bss            :
  {
   *(.bss .bss.* .gnu.linkonce.b.*)
   /* Align here to ensure that the .bss section occupies space up to
      _end.  Align after .bss to ensure correct alignment even if the
      .bss section disappears because there are no input sections.  */
   . = ALIGN(32 / 8);
  } > SRAM 
  PROVIDE(__bss_end = .);
  PROVIDE (_bend = .);
  _end = .;
  PROVIDE (end = .);
  /*. = DATA_SEGMENT_END (.);*/
  
/* BEGIN OF DEBUGGING INFO; DO NOT CHANGE ANYTHING STARTING FROM HERE */
  .comment       0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
/* END OF DEBUGGING INFO; DO NOT CHANGE ANYTHING BEFORE THIS LINE */

  /* set stack top symbol, _stack has to be 8 bytes aligned. */
  PROVIDE (_stack = ORIGIN(SRAM) + LENGTH(SRAM));
  /DISCARD/ : { *(.note.GNU-stack) } > SRAM 
}

